CodeForces 490D Chocolate

题意:

2块矩形巧克力  如果边长可以整除2  则可以从一半出掰开  吃掉一半  如果可以整除3  则可以从1/3处掰开  吃掉1/3  问  最少吃几次  能使得2块面积相同  输出最后时刻的边长

思路:

面积最多只有10^18  因此形成的面积的种类数最多几万种  我们可以利用面积来暴搜出所有状态  然后找面积相同时的最少步数

PS:数论的方法更好

代码:

#include<cstdio>
#include<iostream>
#include<cstring>
#include<string>
#include<algorithm>
#include<map>
#include<set>
#include<vector>
#include<queue>
#include<cstdlib>
#include<ctime>
#include<cmath>
using namespace std;
typedef long long LL;
#define N 1000010

int a[2], b[2];
map<LL, int> res[2];
map<LL, pair<int, int> > way[2];
map<LL, int>::iterator it1, it2;
struct node {
    int x, y;
} f1, f2;
queue<node> q;
int ans;
LL fzc;

int main() {
    LL u, v;
    int now;
    scanf("%d%d%d%d", &a[0], &b[0], &a[1], &b[1]);
    res[0][(LL) (a[0]) * b[0]] = 0;
    res[1][(LL) (a[1]) * b[1]] = 0;
    way[0][(LL) (a[0]) * b[0]] = make_pair(a[0], b[0]);
    way[1][(LL) (a[1]) * b[1]] = make_pair(a[1], b[1]);
    for (int i = 0; i <= 1; i++) {
        f1.x = a[i];
        f1.y = b[i];
        q.push(f1);
        while (!q.empty()) {
            f1 = q.front();
            u = (LL) (f1.x) * f1.y;
            q.pop();
            now = res[i][u];
            if (u % 2 == 0) {
                v = u / 2;
                if (!res[i].count(v)) {
                    res[i][v] = now + 1;
                    if (f1.x % 2 == 0) {
                        f2.x = f1.x / 2;
                        f2.y = f1.y;
                    } else {
                        f2.x = f1.x;
                        f2.y = f1.y / 2;
                    }
                    way[i][v] = make_pair(f2.x, f2.y);
                    q.push(f2);
                }
            }
            if (u % 3 == 0) {
                v = u / 3 * 2;
                if (!res[i].count(v)) {
                    res[i][v] = now + 1;
                    if (f1.x % 3 == 0) {
                        f2.x = f1.x / 3 * 2;
                        f2.y = f1.y;
                    } else {
                        f2.x = f1.x;
                        f2.y = f1.y / 3 * 2;
                    }
                    way[i][v] = make_pair(f2.x, f2.y);
                    q.push(f2);
                }
            }
        }
    }
    ans = -1;
    for (it1 = res[0].begin(), it2 = res[1].begin();
            it1 != res[0].end() && it2 != res[1].end();) {
        if ((*it1).first == (*it2).first) {
            if (ans == -1 || (*it1).second + (*it2).second < ans) {
                ans = (*it1).second + (*it2).second;
                fzc = (*it1).first;
            }
            it1++;
            it2++;
        } else if ((*it1).first > (*it2).first)
            it2++;
        else
            it1++;
    }
    printf("%d\n", ans);
    if (ans >= 0) {
        pair<int, int> tp1 = way[0][fzc], tp2 = way[1][fzc];
        printf("%d %d\n", tp1.first, tp1.second);
        printf("%d %d\n", tp2.first, tp2.second);
    }
    return 0;
}
时间: 2024-10-16 16:53:59

CodeForces 490D Chocolate的相关文章

Codeforces 490D Chocolate(数论)

题目链接:Codeforces 490D Chocolate 两个种变换方式无疑是减掉一个因子3加上一个因子2和减掉一个因子2,所以从因子的角度出发,如果两组数存在不同的质因子肯定是不可以的.剩下的就是构造答案了. #include <cstdio> #include <cstring> #include <cmath> #include <algorithm> using namespace std; const int maxn = 105; int A

codeforces 617B Chocolate

题意: 在给定01串中,问能分割成多少个子串?每个子串只有一个1. dp 1 #include<iostream> 2 #include<string> 3 #include<algorithm> 4 #include<cstdlib> 5 #include<cstdio> 6 #include<set> 7 #include<map> 8 #include<vector> 9 #include<cstr

CodeForces 598E Chocolate Bar

区间DP预处理. dp[i][j][k]表示大小为i*j的巧克力块,切出k块的最小代价. #include<cstdio> #include<cstring> #include<cmath> #include<algorithm> using namespace std; const long long INF=9999999999999999; const int maxn=60; long long dp[maxn][maxn][maxn]; int n

Codeforces Round #257 (Div. 2)449A - Jzzhu and Chocolate(贪心、数学)

题目链接:http://codeforces.com/problemset/problem/449/A ---------------------------------------------------------------------------------------------------------------------------------------------------------- 欢迎光临天资小屋:http://user.qzone.qq.com/593830943

codeforces 598E E. Chocolate Bar(区间dp)

题目链接: E. Chocolate Bar time limit per test 2 seconds memory limit per test 256 megabytes input standard input output standard output You have a rectangular chocolate bar consisting of n × m single squares. You want to eat exactly k squares, so you ma

CodeForces Round 279 D Chocolate

Polycarpus likes giving presents to Paraskevi. He has bought two chocolate bars, each of them has the shape of a segmented rectangle. The first bar is a1 × b1 segments large and the second one is a2 × b2 segments large. Polycarpus wants to give Paras

codeforces 490 D Chocolate

题意:给出a1*b1和a2*b2两块巧克力,每次可以将这四个数中的随意一个数乘以1/2或者2/3,前提是要可以被2或者3整除,要求最小的次数让a1*b1=a2*b2,并求出这四个数最后的大小. 做法:非常显然仅仅跟2跟3有关.所以s1=a1*b1,s2=a2*b2,s1/=gcd(s1,s2),s2/=gcd(s1,s2),然后若s1跟s2的质因子都是2跟3,那么就有解.之后暴力乱搞就好了. #include<map> #include<string> #include<cs

codeforces 555 C Case of Chocolate

一开始题目读错了,还以为可以从任意点为起点向上向左吃. 其实是只能从右边的边界为起点吃. 于是很明显,每一个横坐标最多只能出现一次,否则肯定是当前这个起点的巧克力已经被啃食了. 想到这里就更明显了,对于(xi,n+1-xi),若是向上吃,能够影响它的操作(xj,n+1-xj)肯定满足xj>xi,然后又明显一点,最小的xj肯定能影响到它. 我们来考虑操作(xj,n+1-xj), 若它是往左吃,很显然此时操作(xi,n+1-xi)能吃到被(xj,n+1-xj)吃掉的地方为止. 若它是往上吃呢?很显然

CodeForces 449A - Jzzhu and Chocolate

传送门:Jzzhu and Chocolate 题意: 给出一个N * M的矩阵,给K个操作,每次操作可以横/竖切割矩阵,最后求K次切割之后,矩阵最小的那块面积最大是多少? 分析: 按照题意,题目求的结果是:(最小的面积,最大是多少),那么可以想到,K次切割之后尽量使得每个块的面积相等,某些块比较大(因为不一定能平均分),那么就可以使得最小的那块面积最大了. 然后如何切割呢? 因为有横竖两个切割方法,那么我们可以设X为横切割数,Y为竖切割数,其中(0 <= X, Y <= K),因为最多对一个